#define NRANSI
#define NR_END 1
#define FREE_ARG char*
#define TINY 1.0e-20;
#include<string.h>
#include<math.h>
#include<stdlib.h>
#include<stdio.h>
#define M_PI   3.14159265358979323846
#define s2     1.41421356237309504880
#define s3     1.73205080756887729353
#define MAXIT	50

	int i,ii,j,b,k,r,s,t,u,v,max_sys,mtr,stop,*ins_dir,*ins_vec,no_unload,Ngrain,ep_ini;
	int iter,max_iter,grain,max_grain,scr,step,ms,pg,o1,oo1,o3,oo3;
	int *activ_sys,*indx,*group,gam,max_gam,sing,*as,n_cyc,cycle,st1,st2,st3;
	int *gr_dir,*gr_nor,*gr_tra,shift,redu,max_redu,*pr_mark,max_ref,*grain15,*max_sys15,**activ_sys15;

	double *ep_P,*ep_P_dot,ep_EQ,ep_unload,**stress15,*tau15,mfactor,**L6,sig_dot,sig_ini;
	double xsav,sum_gam,max_gamma,mean_gamma,M_mean,M_min,M_max,pr_check,cyc_ini_sigma;
	double (*nrfunc)(double,double);
	double cos1,sin1,cos2,sin2,cos3,sin3,ny,max_strain,os,plac,max_zero,max_dev,max_dev1,ny12,ny13;
	double temp,temp1,ep_d,ep_dot,tau0,h_ratio,h_ini,h_exp,h_mean,E_modul,aniso;
	double **m,**n,**m1,**n1,**q,*epsilon,nul,*cyc_strain;
	double *e_dot,*s_dot,*sigma,*cardan,*euler,**X,**Y;
	double ***mu,**h,*tau,**omega,*omvec,*teta_dot;
	double *K,**M,**U,**G,**invG,h_0,h_gamma,*s_c,*e_c,*s_c_dot,*e_c_dot,**m_c;
	double **f,**mu_vec,**L,**L_old,**L_c,**l_c,**A_c,**L_star,**l_0,**R,*col,d,det;
	double l_0_11,l_0_12,l_0_44,L_old_11,L_old_12,L_old_44;
	double **mat3,*vec6,*gamma_dot,*tau_dot,ny1,ny2,s_a,s_a_dot;
	double **s_dir,**e_dir,**E_dir,**E_nor,**E_tra,**s_nor,**e_nor,ins_ang,ang,*pr,ep_unload,*ep_E,*ep_temp;
	double **e_stddev,**e_stddev2,*std_dir,*std_nor,var,**e_tra,**s_tra;
	double **car_all,**tau_all,**s_c_all,**e_c_all,*gamma_tot,**e_stddev3,*std_tra;
	double *M_dir,*M_nor,*M_tra;
	int **group_all;

	char in_file[40],out_file[40],grain_file[40],string[40],ch;

	FILE *out_parm,*input,*check,*ini,*str_dir,*str_nor,*stif,*pole,*pole1;
	FILE *stddev,*stddev2,*stddev3,*actsys,*str_tra,*elastic;

	int fflush(FILE *out_parm);

#include"sachs_ut.c"  /*Auxilery routines*/

double roundoff(double value, double round_size)
{
	char str[20];
	int i;
	sprintf(str," %.0f",value*round_size);
	i=atoi(str);
	return i/round_size;

}

int check_dev(void)
{
	b=0;t=0;temp=0;temp1=0;max_dev=0;max_dev1=0;max_zero=0;
	for(i=1;i<=6;i++)
		for(j=1;j<=6;j++)
		{
			if(i>3)
			{
				if(j<4)
				{
					temp = fabs(*(*(L+i)+j)*s2/(*(*(L+4)+4)));
					if(temp>max_zero)
						max_zero = temp;
				}
				else if(i!=j)
				{
					temp = fabs(*(*(L+i)+j)/(*(*(L+4)+4)));
					if(temp>max_zero)
						max_zero = temp;
				}
				else
				{
						temp1 = fabs((*(*(L+i)+j) - *(*(L_old+i)+j))/(*(*(L_old+i)+j)));
						if(temp1>max_dev1)
							max_dev1=temp1;
				}
			}
			else if (j>3)
			{
				temp = fabs(*(*(L+i)+j)*s2/(*(*(L+4)+4)));
				if(temp>max_zero)
					max_zero = temp;
			}
			else
			{
				temp1 = fabs((*(*(L+i)+j) - *(*(L_old+i)+j))/(*(*(L_old+i)+j)));
				if(temp1>max_dev)
				{
					max_dev=temp1;
					b=i;
					t=j;
				}
			}
		}
	return b+t;
}/*int check_dev(void)*/


int main_calc(void)
{
	if(step==1)
		if((input=fopen(grain_file,"r")) == NULL)
		{
			printf("\nCannot open grain file!\n");
			ch=getc(stdin);
			exit(1);
		}
	if((check=fopen("check.dat","w")) == NULL)
	{
		printf("\nCannot open check file!");
		ch=getc(stdin);
		exit(1);
	}
	fprintf(check," Step  Iter  E_1    PG       OS    O1    O3   AS   Max_dev  Redu  Gam    M");
	if(step==1)
		printf("Step  Iter  E_1    PG       OS    O1    O3   AS   Max_dev  Redu  Gam    M");


	max_gam=0;	max_redu=0;

for(iter=1;iter<=max_iter;iter++)
{

	  if(iter > 3 && max_dev < 1e-4)
			iter = max_iter;



if(iter==max_iter)
{
/*	pr_check = *(epsilon+1) + *(e_dot+1);*/
	pr_check = ep_EQ;
	for(i=1;i<=10;i++)
	{
		if(pr_check - *(pr+i) > -1e-6 && *(pr_mark+i)==0)
		{
			sprintf(string,"p_%02d.dat",i);
			if((pole1=fopen(string,"w")) == NULL)
			{
				printf("\nCannot open %s!",string);
				ch=getc(stdin);
				exit(1);
			}
		}
	}
}

	for(i=1;i<=8;i++)
		*(as+i)=0;
	o1=0;o3=0;ms=0;os=0;pg=0;M_mean=0;M_min=10;M_max=0;h_mean=0;
	for(i=1;i<=6;i++)
		*(e_dot+i) = 0;
	for(i=1;i<=6;i++)
		*(s_dot+i) = 0;
	for(i=1;i<=6;i++)
		for(j=1;j<=6;j++)
			*(*(L+i)+j) = 0;
	if(iter==max_iter)
	{
		for(i=1;i<=6;i++)
		{
			for(j=1;j<=max_ref;j++)
			{
				*(*(s_dir+j)+i)=0;
				*(*(e_dir+j)+i)=0;
				*(gr_dir+j)=0;
				*(*(s_nor+j)+i)=0;
				*(*(e_nor+j)+i)=0;
				*(gr_nor+j)=0;
				*(*(s_tra+j)+i)=0;
				*(*(e_tra+j)+i)=0;
				*(gr_tra+j)=0;
				*(*(E_dir+j)+i)=0;
				*(*(E_nor+j)+i)=0;
				*(*(E_tra+j)+i)=0;
			}
			*(ep_P_dot+i)=0;
			*(ep_E+i)=0;
		}
		for(j=1;j<=max_ref;j++)
		{
			*(M_dir+j)=0;
			*(M_nor+j)=0;
			*(M_tra+j)=0;
		}
	}
/*	Start calculations !!!!*/
for(grain=1;grain<=max_grain;grain++)
{
	if(scr=='y')
		if(grain==1 || grain==max_grain)
			printf("\nStep # %3d, cycle # %2d, iteration # %3d, grain # %4d",step,cycle,iter,grain);
	if(step==1 && iter==1)
	{
		fscanf(input,"%lf %lf %lf\n",&euler[1],&euler[2],&euler[3]);
		for(i=1;i<=24;i++)
		{
			*(tau+i)    = *(*(tau_all+grain)+i)   = tau0;
			*(group+i)  = *(*(group_all+grain)+i) = 1;
			if(i<=6)
			{
				*(s_c+i) = *(*(s_c_all+grain)+i)   = 0;
				*(e_c+i) = *(*(e_c_all+grain)+i)   = 0;
			}
		}
		*(s_c+1) = *(*(s_c_all+grain)+1) = 2*tau0;
		*(gamma_tot+grain)=0;
/*	Calculating the cardanian angles*/
		for(i=1;i<=3;i++)
			*(euler+i) *= M_PI/180;
		if(cos(*(euler+2))==0)
			*(cardan+1) = atan2( cos(*(euler+3)) * sin(*(euler+2)) , 1e-10);
		else
			*(cardan+1) = atan2( cos(*(euler+3)) * sin(*(euler+2)) , cos(*(euler+2)));

		if(cos(*(euler+3))==0)
			*(cardan+2) = atan2(-sin(*(euler+3)) , 1e-10);
		else if(sin(*(cardan+1))==0)
			*(cardan+2) = atan2(-sin(*(euler+3)) , 1e10);
		else
			*(cardan+2) = atan2(-sin(*(euler+3)) , cos(*(euler+3)) / sin(*(cardan+1)));

		if(cos(*(euler+3))==0)
			*(cardan+3) = atan2( sin(*(euler+3)) * cos(*(euler+2)) , 1e-10) + *(euler+1);
		else
			*(cardan+3) = atan2( sin(*(euler+3)) * cos(*(euler+2)) , cos(*(euler+3))) + *(euler+1);
		for(i=1;i<=3;i++)
		{
			while(*(cardan+i)<0)
				*(cardan+i) += 2*M_PI;
			while(*(cardan+i)>2*M_PI)
				*(cardan+i) -= 2*M_PI;
			*(*(car_all+grain)+i) = *(cardan+i);
		}
	}
	else
	{
		for(i=1;i<=24;i++)
		{
			*(tau+i) = *(*(tau_all+grain)+i);
			*(group+i) = *(*(group_all+grain)+i);
			if(i<=6)
			{
				*(s_c+i) = *(*(s_c_all+grain)+i);
				*(e_c+i) = *(*(e_c_all+grain)+i);
				if(i<=3)
					*(cardan+i) = *(*(car_all+grain)+i);
			}
		}
	}
	for(i=1;i<=24;i++)
		*(tau_dot+i)=0;

/* Definition of the transformation matrix q*/
	cos1 = cos(*(cardan+1)); /* To avoid calculating cos and*/
	sin1 = sin(*(cardan+1)); /* sin every time, auxilary variables*/
	cos2 = cos(*(cardan+2)); /* are used to reprecent cos and sin!*/
	sin2 = sin(*(cardan+2));
	cos3 = cos(*(cardan+3));
	sin3 = sin(*(cardan+3));
	*(*(q+1)+1)=  cos2*cos3;
	*(*(q+1)+2)=  cos2*sin3;
	*(*(q+1)+3)= -sin2;
	*(*(q+2)+1)= -cos1*sin3 + sin1*sin2*cos3;
	*(*(q+2)+2)=  cos1*cos3 + sin1*sin2*sin3;
	*(*(q+2)+3)=  sin1*cos2;
	*(*(q+3)+1)=  sin1*sin3 + cos1*sin2*cos3;
	*(*(q+3)+2)= -sin1*cos3 + cos1*sin2*sin3;
	*(*(q+3)+3)=  cos1*cos2;

/*	Calculation of the normal and direction vectors*/
	for(b=1;b<=24;b++)
		for(i=1;i<=3;i++)
		{
			*(*(n1+b)+i) = 0;
			*(*(m1+b)+i) = 0;
			for(j=1;j<=3;j++)
			{
				*(*(n1+b)+i) += *(*(q+i)+j) * *(*(n+b)+j);
				*(*(m1+b)+i) += *(*(q+i)+j) * *(*(m+b)+j);
			}
		}
/* Calculation of R values (4. ordet rotation matrix)*/
	for(b=1;b<=6;b++)
		for(t=1;t<=6;t++)
		{
				  if(b==1) {i=1; j=1;}
			else if(b==2) {i=2; j=2;}
			else if(b==3) {i=3; j=3;}
			else if(b==4) {i=2; j=3;}
			else if(b==5) {i=3; j=1;}
						else {i=1; j=2;}
				  if(t==1) {u=1; v=1;}
			else if(t==2) {u=2; v=2;}
			else if(t==3) {u=3; v=3;}
			else if(t==4) {u=2; v=3;}
			else if(t==5) {u=3; v=1;}
						else {u=1; v=2;}
			*(*(R+b)+t) = (*(*(q+i)+u) * *(*(q+j)+v) + *(*(q+i)+v) * *(*(q+j)+u))/2;
			if(b>3)
			{
				if(t>3)
					*(*(R+b)+t) *= 2;
				else
					*(*(R+b)+t) *= s2;
			}
			else if(t>3)
				*(*(R+b)+t) *= s2;
		}
/* Calculation of l_c values (the rotated single crystals)*/
	for(i=1;i<=6;i++)
		for(j=1;j<=6;j++)
		{
			*(*(l_c+i)+j)=0;
			for(u=1;u<=6;u++)
				for(v=1;v<=6;v++)
					*(*(l_c+i)+j) += *(*(R+i)+u) * *(*(l_0+u)+v) * *(*(R+j)+v);
		}

/* Calculation of mu values*/
	for(b=1;b<=24;b++) /* mu_i_j = (m_i * n_j + m_j * n_i)/2*/
		for(i=1;i<=3;i++)
			for(j=1;j<=3;j++)
				*(*(*(mu+b)+i)+j) = ( *(*(m1+b)+i) * *(*(n1+b)+j) + *(*(m1+b)+j) * *(*(n1+b)+i) )/2;
/* Calculation of mu_vec values*/
	for(b=1;b<=24;b++)
	{
		*(*(mu_vec+b)+1) = *(*(*(mu+b)+1)+1);
		*(*(mu_vec+b)+2) = *(*(*(mu+b)+2)+2);
		*(*(mu_vec+b)+3) = *(*(*(mu+b)+3)+3);
		*(*(mu_vec+b)+4) = *(*(*(mu+b)+2)+3)*s2;
		*(*(mu_vec+b)+5) = *(*(*(mu+b)+3)+1)*s2;
		*(*(mu_vec+b)+6) = *(*(*(mu+b)+1)+2)*s2;
	}

	h_gamma = h_0*(1 + (h_ini-1)*exp(-h_exp* *(gamma_tot+grain)));

	for(i=1;i<=24;i++)
		for(j=1;j<=24;j++)
		{
			if(i==j)
				*(*(h+i)+j) = h_gamma;
			else
				*(*(h+i)+j) = h_gamma*h_ratio;
		}
	h_mean += h_gamma;

	for(i=1;i<=6;i++)
		*(s_c_dot+i)=0;
	*(s_c_dot+1)=1;
	temp1=0;
	for(b=1;b<=24;b++)
	{
		temp=0;
		for(i=1;i<=6;i++)
			temp  += *(s_c_dot+i)     * *(*(mu_vec+b)+i);
		if(temp>temp1)
			temp1=temp;
	}
	max_sys=0;
	for(b=1;b<=24;b++)
	{
		temp=0;
		for(i=1;i<=6;i++)
			temp  += *(s_c_dot+i)     * *(*(mu_vec+b)+i);
		if(temp>=0.999*temp1)
		{
			max_sys++;
			*(activ_sys+max_sys) = b;
		}
	}
	if(max_sys>ms)
		ms=max_sys;
	sum_gam = rtsec(gamma_func,0,1e6,fabs(ep_dot/1000));
	for(i=1;i<=max_sys;i++)
		*(gamma_dot+(*(activ_sys+i))) = sum_gam;
	sum_gam *= max_sys;
	temp = 0;
	for(i=1;i<=max_sys;i++)
			temp += *(*(h+(*(activ_sys+1)))+i) * *(gamma_dot+(*(activ_sys+1)));
	for(i=1;i<=6;i++)
		*(s_c_dot+i)=0;
	*(s_c_dot+1) = temp/ *(*(mu_vec+(*(activ_sys+1)))+1);

	mfactor=sum_gam/(*(e_c_dot+1));
	M_mean += mfactor;
	if(mfactor>M_max)
		M_max=mfactor;
	if(max_sys>0 && mfactor<M_min)
		M_min=mfactor;
	if(max_sys>0)
		pg++;

	if(max_sys>ms)
		ms=max_sys;




/* ********** if(iter==max_iter ********** */
	if(iter==max_iter)
	{
/* Calculation of the increment in the Cardanic angles*/
		if(max_sys>0)
		{
			for(i=1;i<=3;i++)		/*Omega_i_j=sum(-(m_i * n_j - m_j * n_i)*gamma/2)*/
				for(j=1;j<=3;j++)	/*for all 24 slipsystems*/
				{
					*(*(omega+i)+j) = 0;
					for(b=1;b<=max_sys;b++)
						*(*(omega+i)+j) -= ( *(*(m1+(*(activ_sys+b)))+i) * *(*(n1+(*(activ_sys+b)))+j) -
													*(*(m1+(*(activ_sys+b)))+j) * *(*(n1+(*(activ_sys+b)))+i) ) *
													*(gamma_dot+(*(activ_sys+b)))/2;
				}
			*(omvec+1)=(*(*(omega+3)+2)- *(*(omega+2)+3))/2;
			*(omvec+2)=(*(*(omega+1)+3)- *(*(omega+3)+1))/2;
			*(omvec+3)=(*(*(omega+2)+1)- *(*(omega+1)+2))/2;

			*(teta_dot+1)= - *(omvec+1) - *(omvec+2)*sin1*sin2/cos2 -
								  *(omvec+3)*cos1*sin2/cos2;

			*(teta_dot+2)=	- *(omvec+2)*cos1 + *(omvec+3)*sin1;

			*(teta_dot+3)=	- *(omvec+2)*sin1/cos2 - *(omvec+3)*cos1/cos2;

			for(i=1;i<=3;i++)
			{
				*(cardan+i) += *(teta_dot+i);
				while(*(cardan+i)<0)
					*(cardan+i) += 2*M_PI;
				while(*(cardan+i)>2*M_PI)
					*(cardan+i) -= 2*M_PI;
			}
		}/*if(max_sys>0)*/
/* Calculating the new Euler angles*/
		if(sin(*(cardan+1)) * cos(*(cardan+2))==0)
			*(euler+3) = atan2(-sin(*(cardan+2)) , 1e-10);
		else
			*(euler+3) = atan2(-sin(*(cardan+2)) , sin(*(cardan+1)) * cos(*(cardan+2)));

		if(cos(*(cardan+1)) * cos(*(cardan+2))==0)
			*(euler+2) = atan2( sin(*(cardan+1)) * cos(*(cardan+2)) / cos(*(euler+3)) , 1e-10);
		else
			*(euler+2) = atan2( sin(*(cardan+1)) * cos(*(cardan+2)) / cos(*(euler+3)) , cos(*(cardan+1)) * cos(*(cardan+2)));

		if(cos(*(euler+3))==0)
			*(euler+1) = *(cardan+3) - atan2( sin(*(euler+3)) * cos(*(euler+2)) , 1e-10);
		else
			*(euler+1) = *(cardan+3) - atan2( sin(*(euler+3)) * cos(*(euler+2)) , cos(*(euler+3)));
		for(i=1;i<=3;i++)
		{
			while(*(euler+i) < 0)
				*(euler+i) += 2*M_PI;
			while(*(euler+i) > 2*M_PI)
				*(euler+i) -= 2*M_PI;
		}
/*		fprintf(pole,"%10.4f %10.4f %10.4f\n",*(euler+1)*180/M_PI,*(euler+2)*180/M_PI,*(euler+3)*180/M_PI);
*/
/* updating arrays */
		*(gamma_tot+grain) += sum_gam;
		for(i=1;i<=24;i++)
		{
			*(*(tau_all+grain)+i) = (*(tau+i) + *(tau_dot+i));
			*(*(group_all+grain)+i) = *(group+i);
		}
		for(i=1;i<=6;i++)
		{
			*(*(s_c_all+grain)+i) = (*(s_c+i) + *(s_c_dot+i));
			*(*(e_c_all+grain)+i) = (*(e_c+i) + *(e_c_dot+i));
		}
		for(i=1;i<=3;i++)
			*(*(car_all+grain)+i) = *(cardan+i);

/* printing to pole files*/

		if(step==2)
		{
				for(j=1;j<=3;j++)
					fprintf(elastic," %8.3f",*(euler+j)*180/M_PI);
				fprintf(elastic," %4d %12.5e\n",step,*(s_c_dot+1)/ *(e_c_dot+1));
		}

		for(i=1;i<=10;i++)
			if(pr_check - *(pr+i) > -1e-6 && *(pr_mark+i)==0)
			{
				for(j=1;j<=3;j++)
					fprintf(pole1," %8.3f",*(euler+j)*180/M_PI);
				fprintf(pole1," %4d %12.5e\n",max_sys,mfactor);
			}
		if(max_sys>0)
			*(as+max_sys) += 1;


	for(i=1;i<=6;i++)
		*(vec6+i) = *(*(s_c_all+grain)+i);
	for(i=1;i<=6;i++)
		*(ep_temp+i) = *(*(e_c_all+grain)+i);

		for(i=1;i<=6;i++)
			*(ep_E+i) += *(ep_temp+i);

		for(i=1;i<=6;i++)
			*(ep_P_dot+i) += *(ep_temp+i);

ins_ang=cos(ang*M_PI/180);
/*ins_ang=cos(2*ang*M_PI/180);*/
		for(i=1;i<=3;i++)
			check_angle1(i,ins_ang,1);
/*ins_ang=cos(ang*M_PI/180);*/
		for(i=4;i<=max_ref;i++)
			check_angle1(i,ins_ang,1);

/*ins_ang=cos(2*ang*M_PI/180);*/
		for(i=1;i<=3;i++)
			check_angle1(i,ins_ang,2);
/*ins_ang=cos(ang*M_PI/180);*/
		for(i=4;i<=max_ref;i++)
			check_angle1(i,ins_ang,2);

/*ins_ang=cos(2*ang*M_PI/180);*/
		for(i=1;i<=3;i++)
			check_angle1(i,ins_ang,3);
/*ins_ang=cos(ang*M_PI/180);*/
		for(i=4;i<=max_ref;i++)
			check_angle1(i,ins_ang,3);

	}/*if(iter==max_iter)*/
	for(i=1;i<=6;i++)
		*(e_dot+i) += *(e_c_dot+i);
	for(i=1;i<=6;i++)
		*(s_dot+i) += *(s_c_dot+i);
	if(iter==1 && step==1)
		for(i=1;i<=6;i++)
			*(s_dot+i) += *(*(s_c_all+grain)+i);

}/*for(grain=1;grain<=max_grain;grain++)*/

	if(step==1 && iter==max_iter)
		fclose(input);
	h_mean /= max_grain;
	if(pg>0)
		M_mean /= pg;
	else
	{
		M_mean=0;
		M_min=0;
	}
	for(i=1;i<=6;i++)
		*(e_dot+i) /= max_grain;
	for(i=1;i<=6;i++)
		*(s_dot+i) /= max_grain;
	fprintf(check,"\n %3d    %2d  %.3f  %4d %8.3f  %4d  %4d  %2d  %.2e   %2d   %2d  %6.3f",step,iter,*(epsilon+1)*100,pg,os,o1,o3,ms,max_dev,max_redu,max_gam,M_mean);
	fflush(check);
	printf("\n %3d    %2d  %.3f  %4d %8.3f  %4d  %4d  %2d  %.2e   %2d   %2d  %6.3f",step,iter,*(epsilon+1)*100,pg,os,o1,o3,ms,max_dev,max_redu,max_gam,M_mean);

}/*for(iter=1;iter<=max_iter;iter++)*/
/* Updating the stress and strain vectors */
	for(i=1;i<=6;i++)
	{
		*(sigma+i)	 	+= *(s_dot+i);
		*(epsilon+i)	+= *(e_dot+i);
		*(ep_P+i)		+= *(ep_P_dot+i)/max_grain;
	}
	temp   = dsqr( *(epsilon+1) - *(epsilon+2) );
	temp  += dsqr( *(epsilon+2) - *(epsilon+3) );
	temp  += dsqr( *(epsilon+3) - *(epsilon+1) );
	temp1  = dsqr( *(epsilon+4) );
	temp1 += dsqr( *(epsilon+5) );
	temp1 += dsqr( *(epsilon+6) );
	ep_EQ	 =	sqrt(temp*2/9 + temp1*4/3);
	for(j=1;j<=max_ref;j++)
	{
		if(*(gr_dir+j)>0)
		{
			for(i=1;i<=6;i++)
			{
				*(*(E_dir+j)+i)/=(*(gr_dir+j));
				*(*(e_dir+j)+i)/=(*(gr_dir+j));
				*(*(s_dir+j)+i)/=(*(gr_dir+j));
			}
			*(M_dir+j)     /=(*(gr_dir+j));
		}
		if(*(gr_nor+j)>0)
		{
			for(i=1;i<=6;i++)
			{
				*(*(E_nor+j)+i)/=(*(gr_nor+j));
				*(*(e_nor+j)+i)/=(*(gr_nor+j));
				*(*(s_nor+j)+i)/=(*(gr_nor+j));
			}
			*(M_nor+j)     /=(*(gr_nor+j));
		}
		if(*(gr_tra+j)>0)
		{
			for(i=1;i<=6;i++)
			{
				*(*(E_tra+j)+i)/=(*(gr_tra+j));
				*(*(e_tra+j)+i)/=(*(gr_tra+j));
				*(*(s_tra+j)+i)/=(*(gr_tra+j));
			}
			*(M_tra+j)     /=(*(gr_tra+j));
		}
		*(std_dir+j) = 0.0;
		*(std_nor+j) = 0.0;
		*(std_tra+j) = 0.0;
		var=0.0;
		if(*(gr_dir+j)>1)
		{
			for(ii=1;ii<=*(gr_dir+j);ii++)
				var += (*(*(e_stddev+ii)+j) - *(*(e_dir+j)+1))*(*(*(e_stddev+ii)+j) - *(*(e_dir+j)+1));
			var /= (*(gr_dir+j) - 1);
			*(std_dir+j) = sqrt(var);
		}
		var=0.0;
		if(*(gr_nor+j)>1)
		{
			for(ii=1;ii<=*(gr_nor+j);ii++)
				var += (*(*(e_stddev2+ii)+j) - *(*(e_nor+j)+2))*(*(*(e_stddev2+ii)+j) - *(*(e_nor+j)+2));
			var /= (*(gr_nor+j) - 1);
			*(std_nor+j) = sqrt(var);
		}
		var=0.0;
		if(*(gr_tra+j)>1)
		{
			for(ii=1;ii<=*(gr_tra+j);ii++)
				var += (*(*(e_stddev3+ii)+j) - *(*(e_tra+j)+2))*(*(*(e_stddev3+ii)+j) - *(*(e_tra+j)+2));
			var /= (*(gr_tra+j) - 1);
			*(std_tra+j) = sqrt(var);
		}
	}
	if(step==1)
	{
		fprintf(str_dir,"\n%12.5e %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e",nul,nul,nul,nul,nul,nul,nul,nul,nul);
		fprintf(str_nor,"\n%12.5e %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e",nul,nul,nul,nul,nul,nul,nul,nul,nul);
		fprintf(str_tra,"\n%12.5e %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e %12.5e",nul,nul,nul,nul,nul,nul,nul,nul,nul);
		 fprintf(stddev,"\n%12.5e %12.5e %12.5e",nul,nul,nul);
		fprintf(stddev2,"\n%12.5e %12.5e %12.5e",nul,nul,nul);
		fprintf(stddev3,"\n%12.5e %12.5e %12.5e",nul,nul,nul);
		for(j=1;j<=max_ref;j++)
		{
			fprintf(str_dir," %4d %12.5e %12.5e %12.5e %12.5e",*(gr_dir+j),nul,nul,nul,nul);
			fprintf(str_nor," %4d %12.5e %12.5e %12.5e %12.5e",*(gr_nor+j),nul,nul,nul,nul);
			fprintf(str_tra," %4d %12.5e %12.5e %12.5e %12.5e",*(gr_tra+j),nul,nul,nul,nul);
			 fprintf(stddev," %12.5e",*(std_dir+j));
			fprintf(stddev2," %12.5e",*(std_nor+j));
			fprintf(stddev3," %12.5e",*(std_tra+j));
		}
	}/*if(step==1)*/
	fprintf(str_dir,"\n%12.5e %12.5e %12.5e",*(epsilon+1)*100,*(sigma+1),ep_EQ*100);
	fprintf(str_nor,"\n%12.5e %12.5e %12.5e",*(epsilon+1)*100,*(sigma+1),ep_EQ*100);
	fprintf(str_tra,"\n%12.5e %12.5e %12.5e",*(epsilon+1)*100,*(sigma+1),ep_EQ*100);
	 fprintf(stddev,"\n%12.5e %12.5e %12.5e",*(epsilon+1)*100,*(sigma+1),ep_EQ*100);
	fprintf(stddev2,"\n%12.5e %12.5e %12.5e",*(epsilon+1)*100,*(sigma+1),ep_EQ*100);
	fprintf(stddev3,"\n%12.5e %12.5e %12.5e",*(epsilon+1)*100,*(sigma+1),ep_EQ*100);
	for(i=1;i<=6;i++)
	{
		fprintf(str_dir," %12.5e",*(ep_E+i)/max_grain);
		fprintf(str_nor," %12.5e",*(ep_E+i)/max_grain);
		fprintf(str_tra," %12.5e",*(ep_E+i)/max_grain);
	}
	for(j=1;j<=max_ref;j++)
	{
		switch(j)
		{
			case 1: temp=291.5; break;
			case 2: temp=109.7; break;
			case 3: temp=227.9; break;
			case 4: temp=173.8; break;
			case 5: temp=243.5; break;
			case 8: temp=202.2; break;
			default: temp=1; break;
		}

		fprintf(str_dir," %4d %12.5e %12.5e %12.5e %12.5e",*(gr_dir+j),*(*(e_dir+j)+1),*(*(s_dir+j)+1)/temp,*(*(E_dir+j)+1),*(M_dir+j));
		fprintf(str_nor," %4d %12.5e %12.5e %12.5e %12.5e",*(gr_nor+j),*(*(e_nor+j)+2),*(*(s_nor+j)+2)/temp,*(*(E_dir+j)+2),*(M_nor+j));
		fprintf(str_tra," %4d %12.5e %12.5e %12.5e %12.5e",*(gr_tra+j),*(*(e_tra+j)+3),*(*(s_tra+j)+3)/temp,*(*(E_dir+j)+3),*(M_tra+j));
		 fprintf(stddev," %12.5e",*(std_dir+j));
		fprintf(stddev2," %12.5e",*(std_nor+j));
		fprintf(stddev3," %12.5e",*(std_tra+j));
	}
	if(scr=='y')
	{
		printf("\n\nSigma_dot:  ");
		for(i=1;i<=6;i++)
			printf(" %9.2f",*(s_dot+i));
		printf("\n\nSigma:      ");
		for(i=1;i<=6;i++)
			printf(" %9.2f",*(sigma+i));
		printf("\n\nEpsilon_dot: ");
		for(i=1;i<=6;i++)
			printf(" %9.5f",*(e_dot+i)*100);
		printf("\n\nEpsilon:     ");
		for(i=1;i<=6;i++)
			printf(" %9.5f",*(epsilon+i)*100);
	}
	ny12 = - *(e_dot+2) / *(e_dot+1);
	ny13 = - *(e_dot+3) / *(e_dot+1);
	max_gamma=0;mean_gamma=0;j=0;
	for(i=1;i<=max_grain;i++)
	{
		if(*(gamma_tot+i) > max_gamma)
			max_gamma = *(gamma_tot+i);
		if(*(gamma_tot+i) > 0)
		{
			j++;
			mean_gamma += *(gamma_tot+i);
		}
	}
	if(j>0)
		mean_gamma /= j;
	for(i=1;i<=6;i++)
		fprintf(out_parm," %7.4f",*(epsilon+i)*100);
	fprintf(out_parm," %7.4f",ep_EQ*100);
	for(i=1;i<=6;i++)
		fprintf(out_parm," %7.3f",*(sigma+i));
	fprintf(out_parm," %7.4f %7.4f %7.4f %4d %2d %7.3f %4d %4d %9.2e %9.2e %7.4f  %2d  %2d",ny,ny12,ny13,pg,ms,os,o1,o3,max_dev,max_dev1,max_zero,max_redu,max_gam);
	fprintf(out_parm," %6.1f %6.3f",h_mean,M_mean);
	for(i=1;i<=8;i++)
		fprintf(out_parm," %4d",*(as+i));
	fprintf(out_parm,"\n");
	fprintf(actsys," %12.5e %12.5e %12.5e",*(epsilon+1)*100,ep_EQ*100,*(sigma+1));
	for(i=1;i<=10;i++)
		if(pr_check - *(pr+i) > -1e-6 && *(pr_mark+i)==0)
		{
			*(pr_mark+i)=1;
			fprintf(pole1,"\n\nepsilon_1 = %.6e %%  ep_EQ = %.6e %%\n",*(epsilon+1)*100,ep_EQ*100);
			fclose(pole1);
		}
	fprintf(actsys,"\n");
	fflush(out_parm);
	fflush(actsys);
	fflush(pole);
	fflush(str_dir);
	fflush(str_nor);
	fflush(str_tra);
	fflush(stddev);
	fflush(stddev2);
	fflush(stddev3);
	fclose(check);
	if(step==2)
		fclose(elastic);
	return 1;
}/*int main_calc(void)*/


int file_ini(void)
{
	if((elastic=fopen("elastic.dat","w")) == NULL)
	{
		printf("\nCannot open elastic file!");
		ch=getc(stdin);
		exit(1);
	}
	if((actsys=fopen("actsys.dat","w")) == NULL)
	{
		printf("\nCannot open actsys file!");
		ch=getc(stdin);
		exit(1);
	}
	if((pole=fopen("pole.dat","w")) == NULL)
	{
		printf("\nCannot open pole file!");
		ch=getc(stdin);
		exit(1);
	}
	if((str_dir=fopen("str_dir.dat","w")) == NULL)
	{
		printf("\nCannot open str_dir file!");
		ch=getc(stdin);
		exit(1);
	}
	if((str_nor=fopen("str_nor.dat","w")) == NULL)
	{
		printf("\nCannot open str_nor file!");
		ch=getc(stdin);
		exit(1);
	}
	if((str_tra=fopen("str_tra.dat","w")) == NULL)
	{
		printf("\nCannot open str_tra file!");
		ch=getc(stdin);
		exit(1);
	}
	if((stddev=fopen("stddev.dat","w")) == NULL)
	{
		printf("\nCannot open stddev file!");
		ch=getc(stdin);
		exit(1);
	}
	if((stddev2=fopen("stddev2.dat","w")) == NULL)
	{
		printf("\nCannot open stddev2 file!");
		ch=getc(stdin);
		exit(1);
	}
	if((stddev3=fopen("stddev3.dat","w")) == NULL)
	{
		printf("\nCannot open stddev3 file!");
		ch=getc(stdin);
		exit(1);
	}
	if((out_parm=fopen("self.dat","w")) == NULL)
	{
		printf("\nCannot open output file!");
		ch=getc(stdin);
		exit(1);
	}
	fprintf(str_dir,"    e_1          s_1          ep_EQ       ep_E_1       ep_E_2       ep_E_3       ep_E_4       ep_E_5       ep_E_6  ");
	fprintf(str_nor,"    e_1          s_1          ep_EQ       ep_E_1       ep_E_2       ep_E_3       ep_E_4       ep_E_5       ep_E_6  ");
	fprintf(str_tra,"    e_1          s_1          ep_EQ       ep_E_1       ep_E_2       ep_E_3       ep_E_4       ep_E_5       ep_E_6  ");
	 fprintf(stddev,"    e_1          s_1          ep_EQ   ");
	fprintf(stddev2,"    e_1          s_1          ep_EQ   ");
	fprintf(stddev3,"    e_1          s_1          ep_EQ   ");

	for(j=1;j<=max_ref;j++)
	{
		switch(j)
		{
			case 1:  strcpy(string,"111"); break;
			case 2:  strcpy(string,"200"); break;
			case 3:  strcpy(string,"220"); break;
			case 4:  strcpy(string,"311"); break;
			case 5:  strcpy(string,"331"); break;
			case 6:  strcpy(string,"420"); break;
			case 7:  strcpy(string,"422"); break;
			case 8:  strcpy(string,"531"); break;
			case 9:  strcpy(string,"620"); break;
			case 10: strcpy(string,"321"); break;
		}
		fprintf(str_dir,"  g%s    e%s_1       s%s_1       E%s_1       M%s_1  ",string,string,string,string,string);
		fprintf(str_nor,"  g%s    e%s_2       s%s_2       E%s_2       M%s_1  ",string,string,string,string,string);
		fprintf(str_tra,"  g%s    e%s_3       s%s_3       E%s_3       M%s_1  ",string,string,string,string,string);
		 fprintf(stddev,"    std%s   ",string);
		fprintf(stddev2,"    std%s   ",string);
		fprintf(stddev3,"    std%s   ",string);
	}
	fprintf(out_parm,"\n\nThe number of grains is: %4d",max_grain);
	fprintf(out_parm,"\nThe strain increment is: %8.3f",ep_d*100);
	fprintf(out_parm,"\nThe maximum strain is:  ");
	for(i=1;i<=n_cyc;i++)
		fprintf(out_parm,"  %7.3f",*(cyc_strain+i)*100);
	fprintf(out_parm,"\nThe angle interval is:  %7.1f",ang);
	fprintf(out_parm,"\nThe chosen material is: ");
	if(mtr=='1')
		fprintf(out_parm,"Stainless steel.");
	else if(mtr=='2')
		fprintf(out_parm,"Aluminium.");
	else if(mtr=='3')
		fprintf(out_parm,"Copper.");
	else if(mtr=='4')
		fprintf(out_parm,"AlCu.");
	else if(mtr=='5')
		fprintf(out_parm,"Tungsten (ISO).");
	fprintf(out_parm,"\nThe chosen tau0 is:      %8.3f MPa\n",tau0);
	fprintf(out_parm,"\nThe Hardening law is Hill hardening");
	fprintf(out_parm,"\nThe ratio between latent and primary hardening is: %5.3f\n",h_ratio);
	fprintf(out_parm,"\nThe final hardening coefficient is: %.0f.",h_0);
	fprintf(out_parm,"\nThe ratio of initial to final hardening coefficient is: %.1f.",h_ini);
	fprintf(out_parm,"\nThe exponential parameter in the hardening law is: %.1f.",h_exp);
	fprintf(out_parm,"\n\n    e_1     e_2     e_3     e_4     e_5     e_6    ep_EQ    s_1     s_2     s_3     s_4     s_5     s_6     ny     ny12    ny13  PlGr Act  Over    O1   O3    Dev       Dev1     Zero  Redu Gam  h_m     M     a1   a2   a3   a4   a5   a6   a7   a8");
	fprintf(out_parm,"  \n  0.0000  0.0000  0.0000  0.0000  0.0000  0.0000  0.0000   0.000   0.000   0.000   0.000   0.000   0.000  %6.04f  %6.04f  %6.04f    0  0   0.000    0    0  0.00e+00  0.00e+00  0.0000   0   0 %6.01f  0.000    0    0    0    0    0    0    0    0\n",ny,ny,ny,h_0*h_ini);
	fflush(out_parm);
	return 0;
}/*int file_ini()*/


int define_arrays(void)
{
	mu				=	f3tensor(1,24,1,3,1,3);
	G				=	matrix(1,6,1,6);
	X				=	matrix(1,12,1,12);
	Y				=	matrix(1,12,1,12);
	invG			=	matrix(1,6,1,6);
	U				=	matrix(1,3,1,3);
	M				=	matrix(1,6,1,6);
	q				=	matrix(1,3,1,3);
	h				=	matrix(1,24,1,24);
	m				=	matrix(1,24,1,3);
	m1				=	matrix(1,24,1,3);
	n				=	matrix(1,24,1,3);
	n1				=	matrix(1,24,1,3);
	mat3			=	matrix(1,3,1,3);
	mu_vec		=	matrix(1,24,1,6);
	f				=	matrix(1,24,1,6);
	L_c			=	matrix(1,6,1,6);
	l_c			=	matrix(1,6,1,6);
	m_c			=	matrix(1,6,1,6);
	A_c			=	matrix(1,6,1,6);
	L_star		=	matrix(1,6,1,6);
	L				=	matrix(1,6,1,6);
	L6				=	matrix(1,6,1,6);
	L_old			=	matrix(1,6,1,6);
	l_0			=	matrix(1,6,1,6);
	R				=	matrix(1,6,1,6);
	omega			=	matrix(1,3,1,3);
	stress15		=	matrix(1,15,1,24);
	M_dir			=	vector(1,10);
	M_nor			=	vector(1,10);
	M_tra			=	vector(1,10);
	tau15			=	vector(1,15);
	K				=	vector(1,3);
	col			=	vector(1,24);
	epsilon		=	vector(1,6);
	e_dot			=	vector(1,6);
	sigma			=	vector(1,6);
	s_dot			=	vector(1,6);
	s_c			=	vector(1,6);
	e_c			=	vector(1,6);
	s_c_dot		=	vector(1,6);
	e_c_dot		=	vector(1,6);
	vec6			=	vector(1,6);
	teta_dot		=	vector(1,3);
	omvec			=	vector(1,6);
	euler			=	vector(1,3);
	cardan		=	vector(1,3);
	tau			=	vector(1,24);
	tau_dot		=	vector(1,24);
	gamma_dot	=	vector(1,24);
	ep_E			=	vector(1,6);
	ep_P			=	vector(1,6);
	ep_P_dot		=	vector(1,6);
	ep_temp		=	vector(1,6);
	pr				=	vector(1,10);
	activ_sys15	=	imatrix(1,15,1,8);
	grain15		=	ivector(1,15);
	max_sys15	=	ivector(1,15);
	indx			=	ivector(1,24);
	group			=	ivector(1,24);
	as				=	ivector(1,8);
	activ_sys	=	ivector(1,12);
	pr_mark		=	ivector(1,10);
/*
	if((ini=fopen("ansi.ini","r")) == NULL)
	{
		printf("\nCannot open ini file!");
		ch=getc(stdin);
		exit(1);
	}
	fscanf(ini,"%s",grain_file);
	fscanf(ini,"%d",&max_grain);
	fscanf(ini,"%lf",&ep_d);
	fscanf(ini,"%lf\n",&max_strain);
	fscanf(ini,"%lf\n",&ang);
	fscanf(ini,"%d\n",&mtr);
	fscanf(ini,"%lf\n",&tau0);
	fscanf(ini,"%lf\n",&h_0);
	fscanf(ini,"%lf\n",&h_ratio);
	fscanf(ini,"%lf\n",&h_ini);
	fscanf(ini,"%lf\n",&h_exp);
	fscanf(ini,"%d\n",&scr);
	fscanf(ini,"%d\n",&n_cyc);
	ins_ang=cos(ang*M_PI/180);
	if(n_cyc==0)
		n_cyc = no_unload = 1;
	else
		no_unload=0;
	cyc_strain =  vector(1,n_cyc);
	*(cyc_strain+n_cyc) = max_strain;
	if(n_cyc>1)
		for(i=1;i<n_cyc;i++)
			fscanf(ini,"%lf\n",(cyc_strain+i));
	fscanf(ini,"%d",&max_ref);
	fclose(ini);
*/
	strcpy(grain_file,"random.dat");
/*	strcpy(grain_file,"randon.dat");
*/	max_grain=5000;
	ep_d=0.0001;
	max_strain=0.051;
	ang=5;
	ins_ang=cos(ang*M_PI/180);
	mtr=1;
	tau0=87;
	h_0=300;
	h_ratio=1;/*1.01*/;
	h_ini=5;
	h_exp=120;
	scr='n';
	n_cyc=1;
	cyc_strain =  vector(1,n_cyc);
	*(cyc_strain+n_cyc) = max_strain;
	no_unload=1;
	max_ref=10;

	car_all		=  matrix(1,max_grain,1,3);
	tau_all		=  matrix(1,max_grain,1,24);
	s_c_all		=  matrix(1,max_grain,1,6);
	e_c_all		=  matrix(1,max_grain,1,6);
	e_stddev		=	matrix(1,max_grain,1,max_ref);
	e_stddev2 	=	matrix(1,max_grain,1,max_ref);
	e_stddev3 	=	matrix(1,max_grain,1,max_ref);
	s_dir			=	matrix(1,max_ref,1,6);
	e_dir			=	matrix(1,max_ref,1,6);
	s_nor			=	matrix(1,max_ref,1,6);
	e_nor			=	matrix(1,max_ref,1,6);
	s_tra			=	matrix(1,max_ref,1,6);
	e_tra			=	matrix(1,max_ref,1,6);
	E_dir			=	matrix(1,max_ref,1,6);
	E_nor			=	matrix(1,max_ref,1,6);
	E_tra			=	matrix(1,max_ref,1,6);
	gamma_tot	=  vector(1,max_grain);
	std_dir		= 	vector(1,max_ref);
	std_nor		= 	vector(1,max_ref);
	std_tra		= 	vector(1,max_ref);
	group_all	= imatrix(1,max_grain,1,24);
	gr_dir		= ivector(1,max_ref);
	gr_nor		= ivector(1,max_ref);
	gr_tra		= ivector(1,max_ref);

/*	printf("grain_file: %s\n",grain_file);
	printf("max_grain:  %d\n",max_grain);
	printf("ep_d:       %f\n",ep_d);
	printf("max_strain: %f\n",max_strain);
	printf("ins_ang:    %f\n",ang);
	printf("mtr:        %c : %d\n",mtr,mtr);
	printf("tau0:       %f\n",tau0);
	printf("h_0:        %f\n",h_0);
	printf("h_ratio:    %f\n",h_ratio);
	printf("h_ini:      %f\n",h_ini);
	printf("h_exp:      %f\n",h_exp);
	printf("scr:        %c : %d\n",scr,scr);
	printf("n_cyc:      %d\n",n_cyc);
	if(n_cyc>0)
		for(i=1;i<=n_cyc;i++)
			printf("inter %d    %f\n",i,*(cyc_strain+i));
	printf("max_ref:    %d\n",max_ref);
	ch=getc(stdin);
	exit(1);
*/
	nul=0;
	return 0;
}/*int define_arrays*/


int array_ini(void)
{
/* Definition of normal vectors*/
	for(i=1;i<=3;i++)
	{
		*(*(n+i)+1) =  1/s3;
		*(*(n+i)+2) =  1/s3;
		*(*(n+i)+3) =  1/s3;
	}
	for(i=4;i<=6;i++)
	{
		*(*(n+i)+1) =  1/s3;
		*(*(n+i)+2) = -1/s3;
		*(*(n+i)+3) = -1/s3;
	}
	for(i=7;i<=9;i++)
	{
		*(*(n+i)+1) = -1/s3;
		*(*(n+i)+2) =  1/s3;
		*(*(n+i)+3) = -1/s3;
	}
	for(i=10;i<=12;i++)
	{
		*(*(n+i)+1) = -1/s3;
		*(*(n+i)+2) = -1/s3;
		*(*(n+i)+3) =  1/s3;
	}
	for(i=1;i<=12;i++)
		for(j=1;j<=3;j++)
			*(*(n+i+12)+j) = *(*(n+i)+j);

/* Definition of direction vectors*/
	*(*(m+1)+1) =  0;
	*(*(m+1)+2) =  1/s2;
	*(*(m+1)+3) = -1/s2;

	*(*(m+2)+1) = -1/s2;
	*(*(m+2)+2) =  0;
	*(*(m+2)+3) =  1/s2;

	*(*(m+3)+1) =  1/s2;
	*(*(m+3)+2) = -1/s2;
	*(*(m+3)+3) =  0;

	*(*(m+4)+1) =  0;
	*(*(m+4)+2) = -1/s2;
	*(*(m+4)+3) =  1/s2;

	*(*(m+5)+1) = -1/s2;
	*(*(m+5)+2) =  0;
	*(*(m+5)+3) = -1/s2;

	*(*(m+6)+1) =  1/s2;
	*(*(m+6)+2) =  1/s2;
	*(*(m+6)+3) =  0;

	*(*(m+7)+1) =  0;
	*(*(m+7)+2) =  1/s2;
	*(*(m+7)+3) =  1/s2;

	*(*(m+8)+1) =  1/s2;
	*(*(m+8)+2) =  0;
	*(*(m+8)+3) = -1/s2;

	*(*(m+9)+1) = -1/s2;
	*(*(m+9)+2) = -1/s2;
	*(*(m+9)+3) =  0;

	*(*(m+10)+1) =  0;
	*(*(m+10)+2) = -1/s2;
	*(*(m+10)+3) = -1/s2;

	*(*(m+11)+1) =  1/s2;
	*(*(m+11)+2) =  0;
	*(*(m+11)+3) =  1/s2;

	*(*(m+12)+1) = -1/s2;
	*(*(m+12)+2) =  1/s2;
	*(*(m+12)+3) =  0;

	for(i=1;i<=12;i++)
		for(j=1;j<=3;j++)
			*(*(m+i+12)+j) = - *(*(m+i)+j);

/* ==========================================================================*/
	if(mtr=='1')				/* Stainless steel */
	{
		l_0_11 	= 204.6e3;	/*Mechanical and Corrosion properties Single Crystal Properties vol. B7 1985*/
		l_0_12 	= 137.7e3;
		l_0_44 	= 2*126.2e3;
		L_old_11	= 260.87e3;
		L_old_12	= 110.06e3;
		L_old_44	= 2*75.85e3;
		ny			= 0.29627187407030958;
		E_modul	= 1.9683558143138737e+05;
		aniso		= 1.1374383;
/*
		*(pr+1)  = 0.0007;
		*(pr+2)  = 0.0009;
		*(pr+3)  = 0.0012;
		*(pr+4)  = 0.0015;
		*(pr+5)  = 0.002;
		*(pr+6)  = 0.003;
		*(pr+7)  = 0.004;
		*(pr+8)  = 0.005;
		*(pr+9)  = 0.01;
		*(pr+10) = 0.03;
*/
	}
	else if(mtr=='2')			/* Aluminium */
	{
		l_0_11	= 108.2e3;	/*G. E. Dieter, Mechanical Metallurgy*/
		l_0_12	= 61.3e3;
		l_0_44	= 2*28.5e3;
		L_old_11	= 112.097e3;
		L_old_12	= 59.35e3;
		L_old_44	= 2*26.372e3;
		ny 		= 0.34624417036784749;
		E_modul	= 7.1032166459922126e+04;
		aniso		= 1.0275512;
/*
		*(pr+1) 	= 0.00035;
		*(pr+2) 	= 0.0005;
		*(pr+3) 	= 0.00075;
		*(pr+4) 	= 0.001;
		*(pr+5) 	= 0.002;
		*(pr+6) 	= 0.003;
		*(pr+7) 	= 0.005;
		*(pr+8) 	= 0.01;
		*(pr+9) 	= 0.02;
		*(pr+10) = 0.03;
*/
	}
	else if(mtr=='3')			/* Copper */
	{
		l_0_11	= 168.4e3;
		l_0_12	= 121.4e3;
		l_0_44	= 2*75.4e3;
		L_old_11	= 201.146e3;
		L_old_12	= 105.025e3;
		L_old_44	= 2*48.303e3;
		ny			= 0.3430314835710887;
		E_modul	= 1.2980248485591639e+05;
		aniso		= 1.1298838;
/*
		*(pr+1)  = 0.00035;
		*(pr+2)  = 0.0004;
		*(pr+3)  = 0.0005;
		*(pr+4)  = 0.0008;
		*(pr+5)  = 0.001;
		*(pr+6)  = 0.0015;
		*(pr+7)  = 0.002;
		*(pr+8)  = 0.003;
		*(pr+9)  = 0.005;
		*(pr+10) = 0.03;
*/
	}
	else if(mtr=='4')			/* AlCu */
	{
		l_0_11	= 92.2e3;
		l_0_12	= 66.5e3;
		l_0_44	= 2*41.3e3;
		L_old_11	= 110.134e3;
		L_old_12	= 57.517e3;
		L_old_44	= 2*26.442e3;
		ny 		= 0.34309764322077202;
		E_modul	= 7.10591588140981040e+04;
		aniso		= 1.1298838;
/*
		*(pr+1)  = 0.00035;
		*(pr+2)  = 0.0004;
		*(pr+3)  = 0.0005;
		*(pr+4)  = 0.0008;
		*(pr+5)  = 0.001;
		*(pr+6)  = 0.0015;
		*(pr+7)  = 0.002;
		*(pr+8)  = 0.003;
		*(pr+9)  = 0.005;
		*(pr+10) = 0.03;
*/
	}
	else
	{
		l_0_11 	= 501e3;		/* Tungsten */
		l_0_12 	= 198e3;
		l_0_44 	= 2*151.5e3;
		L_old_11	= 501e3;
		L_old_12	= 198e3;
		L_old_44	= 2*151.5e3;
		ny 		= 0.2832618025751073;
		E_modul 	= 3.8882832618025749e+05;
		aniso		= 1.0;
/*
		*(pr+1)  = 0.00029;
		*(pr+2)  = 0.00035;
		*(pr+3)  = 0.001;
		*(pr+4)  = 0.002;
		*(pr+5)  = 0.005;
		*(pr+6)  = 0.01;
		*(pr+7)  = 0.02;
		*(pr+8)  = 0.03;
		*(pr+9)  = 0.04;
		*(pr+10) = 0.05;
*/
	}
/*	*(pr+1) 	= 0.00035;
	*(pr+2) 	= 0.0005;
	*(pr+3) 	= 0.001;
	*(pr+4) 	= 0.003;
	*(pr+5) 	= 0.005;
	*(pr+6) 	= 0.01;
	*(pr+7) 	= 0.02;
	*(pr+8) 	= 0.03;
	*(pr+9) 	= 0.04;
	*(pr+10) = 0.05;

	*(pr+1) 	= 0.000025;
	*(pr+2) 	= 0.0001;
	*(pr+3) 	= 0.00035;
	*(pr+4) 	= 0.0011;
	*(pr+5) 	= 0.0035;
	*(pr+6) 	= 0.0085;
	*(pr+7) 	= 0.0182;
	*(pr+8) 	= 0.0280;
	*(pr+9) 	= 0.0377;
	*(pr+10)        = 0.0475;

	*(pr+1) 	= 0.000025;
	*(pr+2) 	= 0.0001;
	*(pr+3) 	= 0.0005;
	*(pr+4) 	= 0.0025;
	*(pr+5) 	= 0.005;
	*(pr+6) 	= 0.01;
	*(pr+7) 	= 0.02;
	*(pr+8) 	= 0.03;
	*(pr+9) 	= 0.04;
	*(pr+10)	= 0.05;
*/
	*(pr+1)=0.005;
	*(pr+2)=0.01;
	*(pr+3)=0.015;
	*(pr+4)=0.02;
	*(pr+5)=0.025;
	*(pr+6)=0.03;
	*(pr+7)=0.035;
	*(pr+8)=0.04;
	*(pr+9)=0.045;
	*(pr+10)=0.05;

	for(i=1;i<=10;i++)
		*(pr_mark+i)=0;
	for(i=1;i<=6;i++)
		for(j=1;j<=6;j++)
		{
			*(*(l_0+i)+j) = 0;
			*(*(L_old+i)+j) = 0;
		}
	*(*(l_0+1)+1) = l_0_11;
	*(*(l_0+2)+2) = l_0_11;
	*(*(l_0+3)+3) = l_0_11;
	*(*(l_0+1)+2) = l_0_12;
	*(*(l_0+1)+3) = l_0_12;
	*(*(l_0+2)+1) = l_0_12;
	*(*(l_0+2)+3) = l_0_12;
	*(*(l_0+3)+1) = l_0_12;
	*(*(l_0+3)+2) = l_0_12;
	*(*(l_0+4)+4) = l_0_44;
	*(*(l_0+5)+5) = l_0_44;
	*(*(l_0+6)+6) = l_0_44;
	*(*(L_old+1)+1) = L_old_11;
	*(*(L_old+2)+2) = L_old_11;
	*(*(L_old+3)+3) = L_old_11;
	*(*(L_old+1)+2) = L_old_12;
	*(*(L_old+1)+3) = L_old_12;
	*(*(L_old+2)+1) = L_old_12;
	*(*(L_old+3)+1) = L_old_12;
	*(*(L_old+2)+3) = L_old_12;
	*(*(L_old+3)+2) = L_old_12;
	*(*(L_old+4)+4) = L_old_44;
	*(*(L_old+5)+5) = L_old_44;
	*(*(L_old+6)+6) = L_old_44;
	for(i=1;i<=6;i++)
	{
		*(s_c+i)=0;
		*(s_c_dot+i)=0;
		*(s_dot+i)=0;
		*(sigma+i)=0;
		*(epsilon+i)=0;
		*(ep_P+i)=0;
	}
	max_dev=0;
	return 0;
}/*int array_ini()*/

int program_end(void)
{
	fclose(out_parm);
	fclose(pole);
	fclose(str_dir);
	fclose(str_nor);
	fclose(str_tra);
	fclose(stddev);
	fclose(stddev2);
	fclose(stddev3);

	free_matrix(car_all,1,max_grain,1,3);
	free_matrix(tau_all,1,max_grain,1,24);
	free_matrix(s_c_all,1,max_grain,1,6);
	free_matrix(e_c_all,1,max_grain,1,6);
	free_matrix(e_stddev,1,max_grain/2,1,max_ref);
	free_matrix(e_stddev2,1,max_grain/2,1,max_ref);
	free_matrix(e_stddev3,1,max_grain/2,1,max_ref);
	free_matrix(s_dir,1,max_ref,1,6);
	free_matrix(e_dir,1,max_ref,1,6);
	free_matrix(s_nor,1,max_ref,1,6);
	free_matrix(e_nor,1,max_ref,1,6);
	free_matrix(s_tra,1,max_ref,1,6);
	free_matrix(e_tra,1,max_ref,1,6);
	free_matrix(E_dir,1,max_ref,1,6);
	free_matrix(E_nor,1,max_ref,1,6);
	free_matrix(E_tra,1,max_ref,1,6);
	free_vector(gamma_tot,1,max_grain);
	free_vector(std_dir,1,max_ref);
	free_vector(std_nor,1,max_ref);
	free_vector(std_tra,1,max_ref);
	free_imatrix(group_all,1,max_grain,1,24);
	free_ivector(gr_dir,1,max_ref);
	free_ivector(gr_nor,1,max_ref);
	free_ivector(gr_tra,1,max_ref);

	free_f3tensor(mu,1,24,1,3,1,3);
	free_matrix(G,1,6,1,6);
	free_matrix(X,1,12,1,12);
	free_matrix(Y,1,12,1,12);
	free_matrix(invG,1,6,1,6);
	free_matrix(U,1,3,1,3);
	free_matrix(M,1,6,1,6);
	free_matrix(q,1,3,1,3);
	free_matrix(h,1,24,1,24);
	free_matrix(m,1,24,1,3);
	free_matrix(m1,1,24,1,3);
	free_matrix(n,1,24,1,3);
	free_matrix(n1,1,24,1,3);
	free_matrix(mat3,1,3,1,3);
	free_matrix(mu_vec,1,24,1,6);
	free_matrix(f,1,24,1,6);
	free_matrix(L_c,1,6,1,6);
	free_matrix(l_c,1,6,1,6);
	free_matrix(m_c,1,6,1,6);
	free_matrix(A_c,1,6,1,6);
	free_matrix(L_star,1,6,1,6);
	free_matrix(L,1,6,1,6);
	free_matrix(L6,1,6,1,6);
	free_matrix(L_old,1,6,1,6);
	free_matrix(l_0,1,6,1,6);
	free_matrix(R,1,6,1,6);
	free_matrix(omega,1,3,1,3);
	free_matrix(stress15,1,15,1,24);
	free_vector(M_dir,1,10);
	free_vector(M_nor,1,10);
	free_vector(M_tra,1,10);
	free_vector(tau15,1,15);
	free_vector(K,1,3);
	free_vector(col,1,24);
	free_vector(epsilon,1,6);
	free_vector(e_dot,1,6);
	free_vector(sigma,1,6);
	free_vector(s_dot,1,6);
	free_vector(s_c,1,6);
	free_vector(e_c,1,6);
	free_vector(s_c_dot,1,6);
	free_vector(e_c_dot,1,6);
	free_vector(vec6,1,6);
	free_vector(teta_dot,1,3);
	free_vector(omvec,1,6);
	free_vector(euler,1,3);
	free_vector(cardan,1,3);
	free_vector(tau,1,24);
	free_vector(tau_dot,1,24);
	free_vector(gamma_dot,1,24);
	free_vector(ep_E,1,6);
	free_vector(ep_P,1,6);
	free_vector(ep_P_dot,1,6);
	free_vector(ep_temp,1,6);
	free_vector(pr,1,10);
	free_imatrix(activ_sys15,1,15,1,8);
	free_ivector(grain15,1,15);
	free_ivector(max_sys15,1,15);
	free_ivector(indx,1,24);
	free_ivector(group,1,24);
	free_ivector(as,1,8);
	free_ivector(activ_sys,1,12);
	free_ivector(ins_dir,1,3);
	free_ivector(ins_vec,1,3);
	free_ivector(pr_mark,1,10);
	if(scr=='y')
		ch=getc(stdin);
	return 0;
}/*int program_end()*/

int cycle_loop(void)
{
	nul=0;
	ep_ini	= fabs(aniso*2*tau0/(E_modul*ep_d/2));
/*	if(ep_ini>1)
		ep_dot	= (ep_ini-1)*ep_d/2;
	else
*/
	ep_dot	= ep_d;
	step=0;	st1=0;	st2=0;	st3=0;	shift=5;		ep_EQ=0;
	max_iter = 1;

	for(cycle=1;cycle<=n_cyc;cycle++)
	{
		while( *(epsilon+1) - *(cyc_strain+cycle) < -1e-6)
/*		while( *(ep_EQ+1) - *(cyc_strain+cycle) < -1e-6)*/
/*		while( *(sigma+1) - *(cyc_strain+cycle) < -1e-6)*/
		{
			step++;
/*			if(step>1 && cycle==1)
			{
				if(pg==max_grain && st1==0)
				{
					st2=step;
					st1=1;
				}
				sprintf(string," %.0f",(*(epsilon+1)+ep_dot)*1e5);
				b=atoi(string);
				if(st1==0)
					ep_dot=ep_d/10;
				else if(step<st2+150)
				{
					if(b%10==0 && step>st2+30)
					{
						st2 = -200;
						st3 = step;
					}
					ep_dot=ep_d/10;
				}
				else if(step <= st3+20)
					ep_dot=ep_d/5;
				else if(step <= st3+40)
					ep_dot=ep_d/2;
				else
					ep_dot=ep_d;
			}
			else if(cycle>1)
*/
				ep_dot=ep_d;

			main_calc();
		}/*while( *(epsilon+1) - *(cyc_strain+cycle) < -1e-6)*/

		if(no_unload!=1)
		{
			ep_dot = -ep_d/10;
			ep_unload = *(epsilon+1);
			for(st3=1;st3<=10;st3++)
			{
				step++;
				main_calc();
			}
/*			ep_unload = *(ep_E+1)/max_grain;*/
/*
			ep_unload = *(sigma+1)/E_modul;
			ep_dot = - (ep_unload - ep_d);
*/
			ep_dot = roundoff(- 2*tau0*aniso/E_modul,1e4);
			step++;
			main_calc();
			ep_dot = -ep_d/10;
/*			for(st3=1;st3<=9;st3++)*/
			while(*(sigma+1)/E_modul > 0.11*ep_d)
			{
				step++;
				main_calc();
			}
/*			ep_dot = - *(ep_E+1)/max_grain;*/
			ep_dot = - *(sigma+1)/E_modul;
			step++;
			main_calc();
			if(cycle<n_cyc)
			{
				ep_dot *= -1;
				step++;
				main_calc();
				ep_dot = ep_d/10;
				for(st3=1;st3<=9;st3++)
				{
					step++;
					main_calc();
				}
/*				ep_dot = ep_unload - ep_d;*/
				ep_dot = roundoff(2*tau0*aniso/E_modul,1e4);
				step++;
				main_calc();
				ep_dot = ep_d/10;
				while(*(epsilon+1) < ep_unload - 1.01*ep_d)
				{
					step++;
					main_calc();
				}
				for(st3=1;st3<=20;st3++)
				{
					step++;
					main_calc();
				}
			}/*if(cycle<n_cyc)*/
		}/*if(no_unload!=1)*/
	}/*for(cycle=1;cycle<=n_cyc;cycle++)*/
	return 1;
}/*int cycle_loop()*/

int main(void)
{
	define_arrays();
	array_ini();
	file_ini();
	cycle_loop();
	program_end();
	return 0;
}/* main*/




