#ifndef _NR_UTILS_H_
#define _NR_UTILS_H_

void nrerror(char error_text[]);
double *vector(int nl, int nh);
int *ivector(int nl, int nh);
double **matrix(int nrl, int nrh, int ncl, int nch);
double ***f3tensor(int nrl, int nrh, int ncl, int nch, int ndl, int ndh);
void free_vector(double *v, int nl, int nh);
void free_ivector(int *v, int nl, int nh);
void free_matrix(double **m, int nrl, int nrh, int ncl, int nch);
void free_f3tensor(double ***t, int nrl, int nrh, int ncl, int nch,int ndl, int ndh);


#endif /* _NR_UTILS_H_ */
